import 'dart:convert';

import 'package:encrypto_flutter/encryptospi.dart';
import 'package:encrypto_flutter/zot_public_key.dart';

import 'keypair.dart';

class Encrypto {
   static const String RSA = "RSA", DES = "DES";
   int bitLength;
   late String _algo;
   String pw;
   late EncryptoSpi _ei;
   late ZotKeyPair keyPair;

   Encrypto(this._algo, {this.bitLength = 1024, this.pw = ''}){
     init();
   }

  void init() {
    String link = "https://github.com/ssddcodes/encrypto/";
    if(_algo.toUpperCase() == DES){
      if(pw.isEmpty || pw.length<8){
        throw Exception("Password can't be null or less then 8 characters long for DES encryption. Please pass the password as 2nd argument. Please refer: $link");
      }
      //TODO
    }else if(_algo.toUpperCase() == RSA){
      _ei = ZotKeyPair(bitLength, this);
    }
  }

  ZotPublicKey getPublicKey(){
     return keyPair.publicKey;
  }

  ZotPublicKey desterilizePublicKey(String base64PublicKey){
    var obj = jsonDecode(String.fromCharCodes(const Base64Decoder().convert(base64PublicKey)));
    return ZotPublicKey(obj['pe'], obj['on']);
  }

  String sterilizePublicKey(){
    String returnPublicKeyB64 = keyPair.publicKey.sterilizePublicKey();
    if(returnPublicKeyB64.isEmpty){
      return "null";
    }
    return returnPublicKeyB64;
  }

   String getPrivateKeyString() {
     String x = _ei.getPrivateKeyString();
     if(x == "null"){
       print("there are no keys ever used for DES local file encryption");
     }
     return x;
   }

   String getPublicKeyString() {
     String x = _ei.getPublicKeyString();
     if(x == ("null")){
       print("there are no keys ever used for DES local file encryption");
     }
     return x;
   }

    String encrypt(String value, {ZotPublicKey? publicKey}){
     return _ei.encrypt(value, publicKey!);
   }

    String decrypt(String value){
     return _ei.decrypt(value);
   }

}
