import 'package:encrypto_flutter/encrypto_flutter.dart';
import 'package:encrypto_flutter/encryptospi.dart';
import 'package:encrypto_flutter/zot_private_key.dart';
import 'package:encrypto_flutter/zot_public_key.dart';

class ZotKeyPair extends EncryptoSpi{

  late ZotPrivateKey _privateKey;
  late ZotPublicKey publicKey;


  ZotKeyPair(int bitLen, Encrypto encrypto){
    _privateKey = ZotPrivateKey(bitLen, this, encrypto);
  }

  @override
  String decrypt(String val) {
    return _privateKey.decrypt(val);
  }

  @override
  String encrypt(String val, ZotPublicKey? publicKey) {
    if(publicKey == null){
      throw Exception("ZotPublicKey can't be null for RSA encryption");
    }
    return publicKey.encrypt(val);
  }

  @override
  String getPrivateKeyString() {
    return _privateKey.toString();
  }

  @override
  String getPublicKeyString() {
    return publicKey.toString();
  }

}